﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using Getstock;

namespace cs_sample
{
    public partial class MainForm : Form
    {
        public GetstockAPI.AuthMemberInfo mMemberInfo;
        public int mIsLogin;
        public string mDatSaveDir;
        public System.Diagnostics.Stopwatch mStpWatch = new System.Diagnostics.Stopwatch();
        ResultForm mResultForm = new ResultForm();
        // 株価データ格納
        // GetstockAPI.RealDataInfo gData = new GetstockAPI.RealDataInfo();
        
        public MainForm()
        {
            InitializeComponent();
        }

        private void CloseBtn_Click(object sender, EventArgs e)
        {
            int aStatus=0;
            if (mIsLogin == 1)
            {
                // ログアウト処理
                GetstockAPI.AuthenticationToServer(ref mMemberInfo, 1, ref aStatus);
            }
            this.Close(); 
        }

        private void GetBtn_Click(object sender, EventArgs e)
        {
            // データ取得
            GetstockAPI.RequestDataInfo aReqInfo = new GetstockAPI.RequestDataInfo ();
            GetstockAPI.AuthMemberInfo aMember = new GetstockAPI.AuthMemberInfo();
            GetstockAPI.RequestPastDataInfo aPastReq = new GetstockAPI.RequestPastDataInfo();
            GetstockAPI.RealStockDataValues[] aStockData = new GetstockAPI.RealStockDataValues[9999];
            GetstockAPI.RealIndexDataValue[] aIndexData = new GetstockAPI.RealIndexDataValue[10];

            uint aMarket;
            int aMethod, aIndexKind;
            int aStatus, result, result1, count;
            int aRecords = 0;
            
            // 保存先Dirを更新
            mDatSaveDir = SaveDirText.Text;
            string file;
            // 過去銘柄用
            int aReqType;
            // 日々データ用
            int aReqDay;
            //　初期設定
            aStatus = 0;
            file = "c:\\";
            aReqType = 0;
            aReqDay = 0;
            mResultForm.ResultView.View = View.Details;
            mResultForm.ResultView.Items.Clear();
            if (StockRadio.Checked || StockRadio1.Checked)
            {
                // 株価表示
                mResultForm.Text = "株価表示";
                mResultForm.ResultView.Columns[0].Text = "証券コード";
                mResultForm.ResultView.Columns[1].Text = "銘柄名";
                mResultForm.ResultView.Columns[2].Text = "取引所";
                mResultForm.ResultView.Columns[3].Text = "日　付";
                mResultForm.ResultView.Columns[4].Text = "時　刻";
                mResultForm.ResultView.Columns[5].Text = "現在値";
                mResultForm.ResultView.Columns[6].Text = "始め値";
                mResultForm.ResultView.Columns[7].Text = "安値";
                mResultForm.ResultView.Columns[8].Text = "高値";
                mResultForm.ResultView.Columns[9].Text = "出来高";
                mResultForm.ResultView.Columns[10].Text = "前日比";
                mResultForm.ResultView.Columns[11].Text = "売り気配";
                mResultForm.ResultView.Columns[12].Text = "買い気配";
            }
            else if (StockListRadio.Checked)
            {
                // 銘柄リスト表示
                mResultForm.Text = "銘柄リスト表示";
                mResultForm.ResultView.Columns[0].Text = "証券コード";
                mResultForm.ResultView.Columns[1].Text = "銘柄名";
                mResultForm.ResultView.Columns[2].Text = "取引所";
                mResultForm.ResultView.Columns[3].Text = "-----";
                mResultForm.ResultView.Columns[4].Text = "-----";
                mResultForm.ResultView.Columns[5].Text = "-----";
                mResultForm.ResultView.Columns[6].Text = "-----";
                mResultForm.ResultView.Columns[7].Text = "-----";
                mResultForm.ResultView.Columns[8].Text = "-----";
                mResultForm.ResultView.Columns[9].Text = "-----";
                mResultForm.ResultView.Columns[10].Text = "-----";
                mResultForm.ResultView.Columns[11].Text = "-----";
                mResultForm.ResultView.Columns[12].Text = "-----";
            }
            else if (IndexRadio.Checked)
            {
                mResultForm.Text = "指標データ表示";
                mResultForm.ResultView.Columns[0].Text = "指標コード";
                mResultForm.ResultView.Columns[1].Text = "指標名";
                mResultForm.ResultView.Columns[2].Text = "日　付";
                mResultForm.ResultView.Columns[3].Text = "時　刻";
                mResultForm.ResultView.Columns[4].Text = "現在値";
                mResultForm.ResultView.Columns[5].Text = "始め値";
                mResultForm.ResultView.Columns[6].Text = "安値";
                mResultForm.ResultView.Columns[7].Text = "高値";
                mResultForm.ResultView.Columns[8].Text = "-----";
                mResultForm.ResultView.Columns[9].Text = "-----";
                mResultForm.ResultView.Columns[10].Text = "-----";
                mResultForm.ResultView.Columns[11].Text = "-----";
                mResultForm.ResultView.Columns[12].Text = "-----";
            }
            else
            {
                //
            }
            // アカウントチェック
            if (ID.TextLength == 0 || Pass.TextLength == 0 || Vendor.TextLength == 0)
            {
                //
                MessageBox.Show("アカウント情報がすべて指定されていません", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            GetBtn.Enabled = false;
            aMarket = 0;
            // 市場コード
            if (TokyoCheck.Checked)
            {
                aMarket += 1;
            }
            if (Tokyo2Check.Checked)
            {
                aMarket += 2;
            }
            if (SapporoCheck.Checked)
            {
                aMarket += 128;
            }
            if (FukuokaCheck.Checked)
            {
                aMarket += 64;
            }
            if (GrowthCheck.Checked)
            {
                aMarket += 256;
            }
            // 日々データ取得種類の論理和計算
            aReqType = 0;
            if (DayCheck.Checked)
            {
                aReqType += 1;
            }
            if (WeekCheck.Checked)
            {
                aReqType += 2;
            }
            if (MonthCheck.Checked)
            {
                aReqType += 4;
            }
            if (ShinyoCheck.Checked)
            {
                aReqType += 8;
            }
            if (aReqType == 0)
            {
                aReqType = 1;
            }
            // 指標
            aIndexKind = 0;
            if (TopixIdxCheck.Checked)
            {
                aIndexKind += 1;
            }
            if (NikkeiCheck.Checked)
            {
                aIndexKind += 2;
            }
            if (GrowthIdxCheck.Checked)
            {
                aIndexKind += 8;
            }
            if (StdIdxCheck.Checked)
            {
                aIndexKind += 16;
            }

            aMember.id = ID.Text;
            aMember.pass = Pass.Text;
            aMember.vendor = Vendor.Text;
            aMember.sessionkey = "";
            aReqInfo.MemberParam = aMember;
            if (StockRadio.Checked)
            {
                if (StockCode1.Text == "")
                {
                    MessageBox.Show("銘柄コードが指定されていません", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    GetBtn.Enabled = true;
                    return;
                }
                aReqInfo.StockParam.scode = StockCode1.Text;
                aReqInfo.StockParam.ecode = "0";
                aReqInfo.StockParam.sType = 0; // 0を指定
                aReqInfo.StockParam.market = aMarket;
                aReqInfo.ReqKind = 0;
                aReqInfo.SaveFile = mDatSaveDir + "\\stockdata_single.txt";
                aReqInfo.Method = 0; // メモリ渡し
            }
            else if (StockRadio1.Checked)
            {
                if (StockCode1.Text == "" || StockCode2.Text == "")
                {
                    MessageBox.Show("銘柄コードが指定されていません", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    GetBtn.Enabled = true;
                    return;
                }
                aReqInfo.StockParam.scode = StockCode1.Text;
                aReqInfo.StockParam.ecode = StockCode2.Text;
                aReqInfo.StockParam.sType = AlphabetCheck.Checked ? 4 : 0;
                aReqInfo.StockParam.market = aMarket;
                aReqInfo.ReqKind = 1;
                aReqInfo.SaveFile = mDatSaveDir + "\\stockdata.txt";
                aReqInfo.Method = 0; // メモリ渡し
            }
            else if (StockListRadio.Checked) {
                if (StockCode1.Text == "" || StockCode2.Text == "")
                {
                    MessageBox.Show("銘柄コードが指定されていません", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    GetBtn.Enabled = true;
                    return;
                }
                aReqInfo.StockParam.scode = StockCode1.Text;
                aReqInfo.StockParam.ecode = StockCode2.Text;
                aReqInfo.StockParam.sType = AlphabetCheck.Checked ? 4 : 0;
                aReqInfo.StockParam.market = aMarket;
                aReqInfo.ReqKind = 2;
                aReqInfo.SaveFile = mDatSaveDir + "\\stocklistdata.txt";
                aReqInfo.Method = 0; // メモリ渡し
            }
            else if (IndexRadio.Checked)
            {
                aReqInfo.ReqKind = 3;
                aReqInfo.IndexParam.IndexType = aIndexKind;
                // ファイル名
                aReqInfo.SaveFile = mDatSaveDir + "\\Indexdata.txt";
                // リクエスト方法
                aReqInfo.Method = 0; // メモリ渡し
            }
            else if (PastRadio.Checked)
            {
                // 銘柄別過去データ
                if (StockCode1.Text == "")
                {
                    MessageBox.Show("銘柄コードが指定されていません", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    GetBtn.Enabled = true;
                    return;
                }
                aPastReq.ReqType = aReqType;
                aPastReq.BrandCode = StockCode1.Text;
                aPastReq.MarketCode = aMarket;
                aPastReq.MemberInfo = aMember;
                aPastReq.SaveDir = mDatSaveDir;
            }
            else if (DayRadio.Checked)
            {
                // 日々過去データ
                if (StockCode1.Text == "")
                {
                    MessageBox.Show("日付が指定されていません", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    GetBtn.Enabled = true;
                    return;
                }
                aPastReq.ReqType = aReqType;
                // aPastReq.BrandCode = Val(StockCode1.Text)
                aReqDay = Convert.ToInt32(StockCode1.Text);
                aPastReq.MarketCode = aMarket;
                aPastReq.MemberInfo = aMember;
                aPastReq.SaveDir = mDatSaveDir;
            }
            else
            {
                aReqInfo.StockParam.scode = "0";
                aReqInfo.StockParam.ecode = "0";
                aReqInfo.StockParam.sType = 0;
                aReqInfo.StockParam.market = 0;
                aReqInfo.ReqKind = 1;
                aReqInfo.SaveFile = "stockdata.txt";
                aReqInfo.Method = 0;
                aReqDay = 0;
                aPastReq.MarketCode = 0;
                aPastReq.MemberInfo = aMember;
                aPastReq.SaveDir = mDatSaveDir;
                MessageBox.Show("取得データ種類が何も指定されてません", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                GetBtn.Enabled = true;
                return;
            }
            aStatus = 100;
            result = 100;
            aMethod = 0;
            // ログイン処理はアプリケーション稼働中最初の一回のみでOK
            if (mIsLogin == 0)
            {
                try
                {
                    // ログイン
                    result = GetstockAPI.AuthenticationToServer(ref aMember, aMethod, ref aStatus);
                    if (result != 0)
                    {
                        // エラー
                        switch (aStatus)
                        {
                            case 61101:
                                MessageBox.Show("タワーチケットは期限切れです", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                break;
                            case 61100:
                                MessageBox.Show("お使いのIDではログインできません", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                break;
                            default:
                                MessageBox.Show(System.Convert.ToString(aStatus), "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                break;
                        }
                        GetBtn.Enabled = true;
                        return;
                    }
                    mMemberInfo.id = aMember.id;
                    mMemberInfo.pass = aMember.pass;
                    mMemberInfo.vendor = aMember.vendor;
                    mMemberInfo.sessionkey = aMember.sessionkey;

                    mIsLogin = 1;
                }
                catch (AccessViolationException ex)
                {
                    MessageBox.Show(ex.Message, "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    GetBtn.Enabled = true;
                    return;
                }
                catch (DllNotFoundException ex)
                {
                    MessageBox.Show(ex.Message, "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    GetBtn.Enabled = true;
                    return;
                }
                catch (BadImageFormatException ex)
                {
                    MessageBox.Show(ex.Message + "\nタワースコープ32bit版を64bitのアプリで使用した、あるいはその逆？", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    GetBtn.Enabled = true;
                    return;
                }
                // メンバー情報をコピー
                aReqInfo.MemberParam = aMember;
            }
            else
            {
                // メンバー情報をコピー
                aReqInfo.MemberParam = mMemberInfo;
            }
            // 時間計測開始
            mStpWatch.Reset();
            mStpWatch.Start();
            // 株価要求
            if (StockListRadio.Checked || StockRadio.Checked || StockRadio1.Checked || IndexRadio.Checked)
            {
                result = GetstockAPI.IndicateGetRealData(ref aReqInfo, ref aRecords, ref aStatus);
                if (result == 0)
                {
                    string aCountStr;
                    // 成功
                    if (StockListRadio.Checked || StockRadio.Checked || StockRadio1.Checked)
                    {
                        for (count = 0; count < aRecords; count++)
                        {
                            aCountStr = count.ToString();
                            result1 = GetstockAPI.GetRealStockDataOneTurn(0, aCountStr, ref aStockData[count], ref aStatus);
                        }
                    }
                    if (IndexRadio.Checked)
                    {
                        for (count = 0; count < aRecords; count++)
                        {
                            result1 = GetstockAPI.GetRealIndexDataOneTurn(count, ref aIndexData[count], ref aStatus);
                        }
                    }
                }
                else
                {
                    // 失敗
                    MessageBox.Show("取得に失敗しました。エラーコード=[" + aStatus.ToString() + "]", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
            // 過去データ要求
            if (PastRadio.Checked)
            {
                result = GetstockAPI.GetPastStockData(ref aPastReq, ref aStatus);
            }
            // 日々データ要求
            if (DayRadio.Checked)
            {
                result = GetstockAPI.GetPastDailyData(ref aPastReq, aReqDay ,ref aStatus);
            }
            // ストップウォッチ停止
            mStpWatch.Stop();
            // 結果チェック
            if (result != 0)
            {
                string aMes = "";
                // エラー
                switch (aStatus)
                {
                    case 61105:
                        aMes = "指定銘柄データがありません";
                        break;
                    case 61102:
                        aMes = "セッション不一致エラーです";
                        break;
                    case 61103:
                        aMes = "セッションタイムアウトです";
                        break;
                    case 61198:
                        aMes = "データ提供元エラー状態です";
                        break;
                    case 61199:
                        aMes = "サーバーの障害によるエラー状態です";
                        break;
                    case 61104:
                        aMes = "要求方法に誤りがあります";
                        break;
                    case 62000:
                        aMes = "前回要求から規定時間経過していません";
                        break;
                    case 61200:
                        aMes = "要求したデータファイルはありません";
                        break;
                    case 61201:
                        aMes = "保存先ディレクトリが存在しません";
                        break;
                    default :
                        aMes = "データ取得エラーです。\r\nエラーコード："+System.Convert.ToString (aStatus);
                        break;

                }
                MessageBox.Show(aMes , "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                GetBtn.Enabled = true;
                return;
            }
            // ログアウト
            // 短時間に連続して要求する場合にはログアウトの必要はありません
            // 一連の取得処理が終わったときに実行するだけで可。ここでは閉じるボタンをクリックしたときに呼んでいます。
            // result = GetstockAPI.AuthenticationToServer(ref aMember, 1, ref aStatus);

            // データ表示
            mResultForm.ResultView.Items.Clear();
            mResultForm.ResultView.FullRowSelect = true;
            if (StockListRadio.Checked || StockRadio.Checked || StockRadio1.Checked)
            {
                // 現物株式
                for (count = 0; count < aRecords; count++)
                {
                    // 取得数分ループ
                    DispStockdatas(aStockData[count]);
                }
            }
            else if (IndexRadio.Checked)
            {
                // 指標
                for (count = 0; count < aRecords; count++)
                {
                    // 取得数分ループ
                    DispIndexdatas(aIndexData[count]);
                }
            }
            else if (PastRadio.Checked)
            {
                MessageBox.Show("指定した銘柄データを取得しました", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                GetBtn.Enabled = true;
                return;
            }
            else if (DayRadio.Checked)
            {
                MessageBox.Show("指定した日々データを取得しました", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                GetBtn.Enabled = true;
                return;
            }
            else
            {
                MessageBox.Show("表示するデータがありません", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                GetBtn.Enabled = true;
                return;
            }
            // 結果表示
            mResultForm.LapseLbl.Text = "取得時間(ミリ秒)：" + System.Convert.ToString(mStpWatch.Elapsed.Milliseconds) + "　　銘柄数：" + aRecords.ToString(); 
            mResultForm.ShowDialog();
            GetBtn.Enabled = true;
            MessageBox.Show("データを取得しました", "株価取得サンプル", MessageBoxButtons.OK, MessageBoxIcon.Information );
        }


        private void MainForm_Load(object sender, EventArgs e)
        {
            // メンバー情報
            mMemberInfo = new GetstockAPI.AuthMemberInfo();
            mIsLogin = 0; // ログイン状態のリセット
            // 過去データファイル保存先ディレクトリの設定
            mDatSaveDir = System.IO.Path.GetDirectoryName(Application.ExecutablePath);
            SaveDirText.Text = mDatSaveDir;
            //初期取得種類を複数銘柄にチェック
            StockRadio1.PerformClick();
        }
        private void DispStockdatas(GetstockAPI.RealStockDataValues InData)
        {
            // データ表示
            ListViewItem aItem = new ListViewItem();
            aItem.Text = InData.Code;
            aItem.SubItems.Add(InData.Name.ToString());
            // 市場名変換
            aItem.SubItems.Add(ConvertMarketName(InData.Market));
            if (StockRadio.Checked || StockRadio1.Checked)
            {
                // 株価データ表示
                // 日付
                aItem.SubItems.Add(InData.DateInfo.DealingDate.ToString());
                // 時間
                aItem.SubItems.Add(InData.DateInfo.DealingTime.ToString());
                // 現在値
                aItem.SubItems.Add(InData.Current.ToString("F1"));
                // 始め値
                aItem.SubItems.Add(InData.Start.ToString("F1"));
                // 安値
                aItem.SubItems.Add(InData.Low.ToString("F1"));
                // 高値
                aItem.SubItems.Add(InData.High.ToString("F1"));
                // 出来高
                aItem.SubItems.Add(InData.Amount.ToString());
                // 前日比
                aItem.SubItems.Add(InData.Ratio.ToString("F1"));
                // 売り気配
                aItem.SubItems.Add(InData.SellConsideration.ToString("F1"));
                // 買い気配
                aItem.SubItems.Add(InData.BuyConsideration.ToString("F1"));
            }
            else
            {
                // 銘柄リスト表示
                // 日付
                aItem.SubItems.Add(" ");
                // 時間
                aItem.SubItems.Add(" ");
                // 現在値
                aItem.SubItems.Add(" ");
                // 始め値
                aItem.SubItems.Add(" ");
                // 安値
                aItem.SubItems.Add(" ");
                // 高値
                aItem.SubItems.Add(" ");
                // 出来高
                aItem.SubItems.Add(" ");
                // 前日比
                aItem.SubItems.Add(" ");
                // 売り気配
                aItem.SubItems.Add(" ");
                // 買い気配
                aItem.SubItems.Add(" ");
            }
            // 追加
            mResultForm.ResultView.Items.Add(aItem);
        }

        private void DispIndexdatas(GetstockAPI.RealIndexDataValue InData)
        {
            // データ表示
            ListViewItem aItem = new ListViewItem();
            // 指標コード
            aItem.Text = InData.IndexType.ToString();
            // 指標名
            aItem.SubItems.Add(InData.Name);
            // 日付
            aItem.SubItems.Add(InData.DateInfo.DealingDate);
            // 時間
            aItem.SubItems.Add(InData.DateInfo.DealingTime);
            // 現在値
            aItem.SubItems.Add(InData.Current.ToString("F1"));
            // 始め値
            aItem.SubItems.Add(InData.Start.ToString("F1"));
            // 安値
            aItem.SubItems.Add(InData.Low.ToString("F1"));
            // 高値
            aItem.SubItems.Add(InData.High.ToString("F1"));
            // 出来高
            aItem.SubItems.Add(" ");
            // 前日比
            aItem.SubItems.Add(" ");
            // 売り気配
            aItem.SubItems.Add(" ");
            // 買い気配
            aItem.SubItems.Add(" ");
            // 追加
            mResultForm.ResultView.Items.Add(aItem);
        }

        
        private string ConvertMarketName(uint InCode)
        {
            string aStr = "";
            switch (InCode)
            {
                case 1: aStr = "東証プライム"; break;
                case 2: aStr = "東証スタンダード"; break;
                case 16: aStr = "名証プレミア"; break;
                case 32: aStr = "名証メイン"; break;
                case 64: aStr = "福岡"; break;
                case 128: aStr = "札幌"; break;
                case 256: aStr = "東証グロース"; break;
                case 2048: aStr = "名証ネクスト"; break;
                default : aStr = "その他"; break;
            }
            return aStr;
        }

        private void IndexRadio_Click(object sender, EventArgs e)
        {
            // 指標の場合には銘柄コード関係は無効にする
            StockCode1.Enabled = false;
            StockCode1.BackColor = SystemColors.ButtonFace;
            StockCode2.Enabled = false;
            StockCode2.BackColor = SystemColors.ButtonFace;
            Tokyo2Check.Enabled = false;
            TokyoCheck.Enabled = false;
            SapporoCheck.Enabled = false;
            FukuokaCheck.Enabled = false;
            GrowthCheck.Enabled = false;
            DayCheck.Enabled = false;
            WeekCheck.Enabled = false;
            MonthCheck.Enabled = false;
            ShinyoCheck.Enabled = false;
            SaveDirText.Enabled = false;
            TopixIdxCheck.Enabled = true;
            NikkeiCheck.Enabled = true;
            GrowthIdxCheck.Enabled = true;
            StdIdxCheck.Enabled = true;
            AlphabetCheck.Enabled = false;
        }

        private void StockRadio1_Click(object sender, EventArgs e)
        {
            StockLbl1.Text = "開始銘柄コード";
            StockCode1.Enabled = true;
            StockCode1.BackColor = SystemColors.Window ;
            StockCode2.Enabled = true;
            StockCode2.BackColor = SystemColors.Window ;
            Tokyo2Check.Enabled = true;
            TokyoCheck.Enabled = true;
            SapporoCheck.Enabled = true;
            FukuokaCheck.Enabled = true;
            GrowthCheck.Enabled = true;
            DayCheck.Enabled = false;
            WeekCheck.Enabled = false;
            MonthCheck.Enabled = false;
            ShinyoCheck.Enabled = false;
            SaveDirText.Enabled = false;
            TopixIdxCheck.Enabled = false;
            NikkeiCheck.Enabled = false;
            GrowthIdxCheck.Enabled = false;
            StdIdxCheck.Enabled = false;
            AlphabetCheck.Enabled = true;
        }

        private void StockRadio_Click(object sender, EventArgs e)
        {
            StockLbl1.Text = "銘柄コード";
            StockCode1.Enabled = true;
            StockCode1.BackColor = SystemColors.Window;
            StockCode2.Enabled = false ;
            StockCode2.BackColor = SystemColors.ButtonFace ;
            Tokyo2Check.Enabled = true;
            TokyoCheck.Enabled = true;
            SapporoCheck.Enabled = true;
            FukuokaCheck.Enabled = true;
            GrowthCheck.Enabled = true;
            DayCheck.Enabled = false;
            WeekCheck.Enabled = false;
            MonthCheck.Enabled = false;
            ShinyoCheck.Enabled = false;
            SaveDirText.Enabled = false;
            TopixIdxCheck.Enabled = false;
            NikkeiCheck.Enabled = false;
            GrowthIdxCheck.Enabled = false;
            StdIdxCheck.Enabled = false;
            AlphabetCheck.Enabled = false;
        }


        private void PastRadio_Click(object sender, EventArgs e)
        {
            StockLbl1.Text = "過去銘柄コード";
            StockCode1.Enabled = true;
            StockCode1.BackColor = SystemColors.Window;
            StockCode2.Enabled = false;
            StockCode2.BackColor = SystemColors.ButtonFace;
            Tokyo2Check.Enabled = true;
            TokyoCheck.Enabled = true;
            SapporoCheck.Enabled = true;
            FukuokaCheck.Enabled = true;
            GrowthCheck.Enabled = true;
            DayCheck.Enabled = true;
            WeekCheck.Enabled = true;
            MonthCheck.Enabled = true;
            ShinyoCheck.Enabled = true;
            DayCheck.Checked = true;
            WeekCheck.Checked = false;
            MonthCheck.Checked = false;
            ShinyoCheck.Checked = false;
            SaveDirText.Enabled = true;
            TopixIdxCheck.Enabled = false;
            NikkeiCheck.Enabled = false;
            GrowthIdxCheck.Enabled = false;
            StdIdxCheck.Enabled = false;
            AlphabetCheck.Enabled = false;
        }


        private void DayRadio_Click(object sender, EventArgs e)
        {
            StockLbl1.Text = "年月日(YYYYMMDD)";
            StockCode1.Enabled = true;
            StockCode1.BackColor = SystemColors.Window;
            StockCode2.Enabled = false;
            StockCode2.BackColor = SystemColors.ButtonFace;
            Tokyo2Check.Enabled = false;
            TokyoCheck.Enabled = false;
            SapporoCheck.Enabled = false;
            FukuokaCheck.Enabled = false;
            GrowthCheck.Enabled = false;
            DayCheck.Enabled = true;
            WeekCheck.Enabled = false;
            MonthCheck.Enabled = false;
            ShinyoCheck.Enabled = true;
            DayCheck.Checked = true;
            WeekCheck.Checked = false;
            MonthCheck.Checked = false;
            ShinyoCheck.Checked = false;
            SaveDirText.Enabled = true;
            TopixIdxCheck.Enabled = false;
            NikkeiCheck.Enabled = false;
            GrowthIdxCheck.Enabled = false;
            StdIdxCheck.Enabled = false;
            AlphabetCheck.Enabled = false;
        }

        private void StockListRadio_Click(object sender, EventArgs e)
        {
            // 銘柄リストボタンがクリックされた
            StockLbl1.Text = "開始銘柄コード";
            StockCode1.Enabled = true;
            StockCode1.BackColor = SystemColors.Window;
            StockCode2.Enabled = true;
            StockCode2.BackColor = SystemColors.Window;
            Tokyo2Check.Enabled = true;
            TokyoCheck.Enabled = true;
            SapporoCheck.Enabled = true;
            FukuokaCheck.Enabled = true;
            GrowthCheck.Enabled = true;
            DayCheck.Enabled = false;
            WeekCheck.Enabled = false;
            MonthCheck.Enabled = false;
            ShinyoCheck.Enabled = false;
            SaveDirText.Enabled = false;
            TopixIdxCheck.Enabled = false;
            NikkeiCheck.Enabled = false;
            GrowthIdxCheck.Enabled = false;
            StdIdxCheck.Enabled = false;
            AlphabetCheck.Enabled = true;
        }
    }
}
