// common.cs
// Visual C# 2008 ȍ~ p
// \ `t@C
// 2023-12-1 
using System.Runtime.InteropServices;
using System.Text;


namespace Getstock
{
public class GetstockAPI
{
    [StructLayout(LayoutKind.Sequential)]
    public struct RequestStockParam
    {
        public int sType;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 8)]
        public string scode;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 8)]
        public string ecode;
        public uint market;
    };

    [StructLayout(LayoutKind.Sequential)]
    public struct RequestIndexParam
    {
        public int IndexType;
    };

    [StructLayout(LayoutKind.Sequential)]
    public struct AuthMemberInfo
    {
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
        public string id;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
        public string pass;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
        public string vendor;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 33)]
        public string sessionkey;
    };

    [StructLayout(LayoutKind.Sequential)]
    public struct RequestDataInfo
    {
        public int ReqKind;
        public RequestStockParam StockParam;
        public RequestIndexParam IndexParam;
        public AuthMemberInfo MemberParam;
        public int Method;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 260)]
        public string SaveFile;
    };


    [StructLayout(LayoutKind.Sequential)]
    public struct RequestPastDataInfo
    {
        public int ReqType;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 8)]
        public string BrandCode;
        public uint MarketCode;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 260)]
        public string SaveDir;    //  \ ͕sv([g͏)
        public AuthMemberInfo MemberInfo;
        public int OpMode;
    };

    // AvɕԂ  
    // 
    [StructLayout(LayoutKind.Sequential)]
    public struct DateTimeInfo
    {
        public int Year;
        public int Month;
        public int Day;
        public int Hour;
        public int Minutes;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]
        public string DealingDate;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 8)]
        public string DealingTime;
    };

    // ̊ 
    [StructLayout(LayoutKind.Sequential)]
    public struct RealStockDataValues
    {
        public uint IsValid;
        public DateTimeInfo DateInfo;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 8)]
        public string Code;
        public uint Market;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 80)]
        public string Name;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 80)]
        public string Yomi;
        public double Current;
        public double Ratio;
        public double Start;
        public double Low;
        public double High;
        public double End;
        public uint Amount;
        public uint Unit;
        public uint IssueStock;
        public double SellConsideration;
        public double BuyConsideration;
        public double SellConsideration7th;
        public double SellConsideration6th;
        public double SellConsideration5th;
        public double SellConsideration4th;
        public double SellConsideration3rd;
        public double SellConsideration2nd;
        public double SellConsideration1st;
        public double BuyConsideration1st;
        public double BuyConsideration2nd;
        public double BuyConsideration3rd;
        public double BuyConsideration4th;
        public double BuyConsideration5th;
        public double BuyConsideration6th;
        public double BuyConsideration7th;
        public uint Concession1;
        public uint Concession2;
        public uint Concession3;
        public uint Concession4;
    };
    // AvɕԂ  wW
    [StructLayout(LayoutKind.Sequential)]
    public struct RealIndexDataValue
    {
        public uint IsValid;
        public uint IndexType;
        public DateTimeInfo DateInfo;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 80)]
        public string Name;
        public double Start;
        public double High;
        public double Low;
        public double Current;
        public double Ratio;
    };
    // 
    [StructLayout(LayoutKind.Sequential, Pack = 4)]
    public struct RealDataInfo
    {
    	public int          DataNum;     /* vAтɎ擾łf[^̑ */
	    public int          IsRemain;    /* cf[^邩(=1 ) */
    	public uint         Month;       /* ̌(gp)  */
        public uint         Day;         /* ̓(gp)  */
        public uint         ContentsSize;  /* URLRecTCY */
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 100)]
        public RealStockDataValues[]    StockData;
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 20)]
        public RealIndexDataValue[]     IndexData;
    };
    // DLL Import
    [DllImport("getstock.dll")]
    public static extern int AuthenticationToServer(ref AuthMemberInfo InAuthInfo, int InMethod, ref int OutStatus);

    [DllImport("getstock.dll")]
    public static extern int GetRealStockData(ref RequestDataInfo InRequest, ref RealDataInfo DataInfo, ref StringBuilder Datas, ref uint DataSize, ref int Records, ref int OutStatus);

    [DllImport("getstock.dll")]
    public static extern int GetPastStockData(ref RequestPastDataInfo InReqInfo, ref int OutStatus);

    [DllImport("getstock.dll")]
    public static extern int GetPastDailyData(ref RequestPastDataInfo InReqInfo, int Date, ref int OutStatus);

    [DllImport("getstock.dll")]
    public static extern int IndicateGetRealData(ref RequestDataInfo InRequest, ref int Records, ref int OutStatus);

    [DllImport("getstock.dll")]
    public static extern int GetRealStockDataOneTurn(int Mode, string Num, ref RealStockDataValues Data, ref int OutStatus);

    [DllImport("getstock.dll")]
    public static extern int GetRealIndexDataOneTurn(int Num, ref RealIndexDataValue Data, ref int OutStatus);

}
}
