' common.vb
' Visual BASIC .NET (2008ȍ~) p
' \ `t@C
' 2023-12-1 
' 
Imports Microsoft.VisualBasic
Imports System.Runtime.InteropServices
Imports System.Text

Public Class GetstockAPI
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure RequestStockParam
        Public sType As Integer
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=8)> _
        Public scode As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=8)> _
        Public ecode As String
        Public market As UInteger
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure RequestIndexParam
        Public IndexType As Integer
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure AuthMemberInfo
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Public id As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Public pass As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Public vendor As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=33)> _
        Public sessionkey As String
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure RequestDataInfo
        Public ReqKind As Integer
        Public StockParam As RequestStockParam
        Public IndexParam As RequestIndexParam
        Public MemberParam As AuthMemberInfo
        Public Method As Integer
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=260)> _
        Public SaveFile As String
    End Structure


    <StructLayout(LayoutKind.Sequential)> _
    Public Structure RequestPastDataInfo
        Public ReqType As Integer
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=8)> _
        Public BrandCode As String
        Public MarketCode As Integer
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=260)> _
        Public SaveDir As String    ' \ ͕sv([g͏)
        Public MemberInfo As AuthMemberInfo
        Public OpMode As Integer
    End Structure

    ' =======================================================================================
    '    ĂяoɕԂ
    ' =======================================================================================

    ' 
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure DateTimeInfo
        Public Year As Integer
        Public Month As Integer
        Public Day As Integer
        Public Hour As Integer
        Public Minutes As Integer
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=16)> _
        Public DealingDate As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=8)> _
        Public DealingTime As String
    End Structure

    ' ̊ 
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure RealStockDataValues
        Public IsValid As UInteger
        Public DateInfo As DateTimeInfo
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=8)> _
        Public Code As String
        Public Market As UInteger
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=80)> _
        Public Name As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=80)> _
        Public Yomi As String
        Public Current As Double
        Public Ratio As Double
        Public Start As Double
        Public Low As Double
        Public High As Double
        Public Finish As Double
        Public Amount As UInteger
        Public Unit As UInteger
        Public IssueStock As UInteger
        Public SellConsideration As Double
        Public BuyConsideration As Double
        Public SellConsideration7th As Double
        Public SellConsideration6th As Double
        Public SellConsideration5th As Double
        Public SellConsideration4th As Double
        Public SellConsideration3rd As Double
        Public SellConsideration2nd As Double
        Public SellConsideration1st As Double
        Public BuyConsideration1st As Double
        Public BuyConsideration2nd As Double
        Public BuyConsideration3rd As Double
        Public BuyConsideration4th As Double
        Public BuyConsideration5th As Double
        Public BuyConsideration6th As Double
        Public BuyConsideration7th As Double
        Public Concession1 As UInteger
        Public Concession2 As UInteger
        Public Concession3 As UInteger
        Public Concession4 As UInteger
    End Structure

    ' wW
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure RealIndexDataValue
        Public IsValid As UInteger
        Public IndexType As UInteger
        Public DateInfo As DateTimeInfo
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=80)> _
        Public Name As String
        Public Start As Double
        Public High As Double
        Public Low As Double
        Public Current As Double
        Public Ratio As Double
    End Structure

    ' 
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure RealDataInfo
        Public DataNum As Integer
        Public Remain As Integer
        Public Month As UInteger
        Public Day As UInteger
        Public ContentsSize As UInteger
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=9999)> _
        Public StockData As RealStockDataValues
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=20)> _
        Public IndexData As RealIndexDataValue
    End Structure

    ' DLL Import
    <DllImport("getstock.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Shared Function AuthenticationToServer(ByRef InAuthInfo As AuthMemberInfo, ByVal InMethod As Integer, ByRef OutStatus As Integer) As Integer
    End Function
    <DllImport("getstock.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Shared Function GetRealStockData(ByRef InRequest As RequestDataInfo, ByRef OutStatus As Integer) As Integer
    End Function
    <DllImport("getstock.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Shared Function IndicateGetRealData(ByRef InRequest As RequestDataInfo, ByRef Records As Integer, ByRef OutStatus As Integer) As Integer
    End Function
    <DllImport("getstock.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Shared Function GetRealStockDataOneTurn(ByVal Mode As Integer, ByVal Num As String, ByRef Data As RealStockDataValues, ByRef OutStatus As Integer) As Integer
    End Function
    <DllImport("getstock.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Shared Function GetRealIndexDataOneTurn(ByVal Num As Integer, ByRef Data As RealIndexDataValue, ByRef OutStatus As Integer) As Integer
    End Function
    <DllImport("getstock.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Shared Function GetPastStockData(ByRef InReqInfo As RequestPastDataInfo, ByRef OutStatus As Integer) As Integer
    End Function
    <DllImport("getstock.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Shared Function GetPastDailyData(ByRef InReqInfo As RequestPastDataInfo, ByVal InDate As Integer, ByRef OutStatus As Integer) As Integer
    End Function


End Class
